/*
Scrivere un programma per la gestione degli iscritti a un torneo di calcetto. Ogni  iscritto  caratterizzato dalle seguenti informazioni: Cognome e Nome, numero di tessera, Nome squadra, data di iscrizione (aaaa/mm/aa).
Gli iscritti sono organizzati in memoria come un vettore con 55 elementi.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Inserimento di una nuovo iscritto;
2) Cambio della squadra (chiedere il numero di tessera e la nuova squadra);
3) Visualizzazione degli iscritti a una certa squadra;
4) Salvataggio su file degli iscritti con data di iscrizione antecedente a una certa data (da inserire tramite tastiera).

All'avvio del programma i valori precedentemente salvate su file devono essere letti e copiati nel vettore mediante una funzione di inizializzazione del vettore

*/


#include <stdio.h>
#include <string.h>

struct iscritto {
       char nome[30];
       int ntessera;
       char nomesquadra[30];
       char data[12];
       };
       
       void inserimento(struct iscritto *V,int *pn)
       {
         struct iscritto p;
         
         if(*pn<55)
         {
           printf("inserisci cognome e nome(cognome/nome): ");
           scanf("%s",p.nome);
           printf("inserisci il numero di tessera: ");
           scanf("%d",&p.ntessera);
           printf("inserisci il nome della squadra: ");
           scanf("%s",p.nomesquadra);
           printf("inserisci la data di iscrizione(aaaa/mm/gg): ");
           scanf("%s",p.data);
           
           V[*pn]=p;
           (*pn)++;
         }
         else printf("Vettore pieno\n");
       }
       
       void cambio(struct iscritto *V,int n)
       {
          int numero,i;
          char nomesquadra[30];
          
          printf("inserisci il numero della tessera: ");
          scanf("%d",&numero);
          
          for(i=0;i<n;i++)
          if(V[i].ntessera==numero)
          break;
          
          if(i<n)
          {
            printf("inserisci il nome della nuova squadra: ");
            scanf("%s",V[i].nomesquadra);
        
          }
         else printf("Elemento non trovato\n");
       }
       
       void visualizza(struct iscritto *V,int n)
       {
         int i;
         char squadra[30];
         
         printf("Inserisci la squadra che vuoi visualizzare: ");
         scanf("%s",squadra);
         
         for(i=0;i<n;i++)
           if(strcmp(V[i].nomesquadra,squadra)==0)
            {
             printf("cognome e nome : %s\n",V[i].nome);
             printf("Numero tessera: %d\n",V[i].ntessera);
             printf("Data(aaaa/mm/gg): %s\n",V[i].data);
            }
       }

     void salva(struct iscritto *V,int n)
     {
          FILE *pf;
          char data[12];
          int i;
          
          printf("Salva gli iscritti con data antecedente al (aaaa/mm/gg): ");
          scanf("%s",data);
           
                
          pf=fopen("iscritti.isc","wb");
            if(pf!=NULL)
            {
               
              for(i=0;i<n;i++)
                 if(strcmp(V[i].data,data) < 0) 
                     fwrite(&V[i],sizeof(struct iscritto),1,pf);
              
              fclose(pf);
              
            }
            else printf("ERRORE\n");
          
     }
     
     void inizializza(struct iscritto *V,int *pn)
     {
       FILE *pf;
       struct iscritto p;
       int i=0;
       
       pf=fopen("iscritti.isc","rb");
       if(pf!=NULL)
       { while(i<55 && fread(&p,sizeof(struct iscritto),1,pf)>0)
         {
           V[i]=p;
           i++;
         }
         fclose(pf);
       }
       else printf("ERRORE\n");
        (*pn)=i;
     } 
     
     
     
    main()
    {
      struct iscritto P[55];
      int n,scelta;
     
     
      inizializza(P,&n);
      
      do {
          printf("Scegli: \n");
          printf("1)inserimento\n2)visualizza\n3)Cambio\n4)salva\n0)fine\n");
          scanf("%d",&scelta);
          
          switch(scelta) {
                         case 1: inserimento(P,&n);
                                 break;
                         case 2: visualizza(P,n);
                                 break;
                         case 3: cambio(P,n);
                                 break;
                         case 4: salva(P,n);
                                 break;
                             
                             default:;
                         }
         } while(scelta!=0);
    }                            
