/*
Scrivere un programma per la gestione dei verbali d'esame. Ogni  esame  caratterizzato dalle seguenti informazioni: cognome e nome studente, matricola, voto, data esame.
Gli esami sono organizzati in memoria come un vettore di 50 elementi
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Inserimento di un nuovo esame;
2)Visualizzazione degli esami relativi a una certa data;
3) Ordinamento degli elementi rispetto alla matricola;
4) Salvataggio su file degli esami.

All'avvio del programma i valori precedentemente salvate su file devono essere letti e copiati nel vettore mediante una funzione di inizializzazione del vettore. 

*/

#include <stdio.h>
#include <string.h>

struct esame
{
       char cognome[20];
       char nome[20];
       long matricola;
       int voto;
       char dataesame[12];
       };
       
 void inserimento (struct esame *E, int *pn)
 {
      struct esame e;
      
      if(*pn<50)
      {
                printf("Cognome: ");
                scanf("%s",e.cognome);
                printf("Nome: ");
                scanf("%s",e.nome);
                printf("Matricola: ");
                scanf("%ld",&e.matricola);
                printf("Voto: ");
                scanf("%d",&e.voto);
                printf("Data esame (gg/mm/aaaa): ");
                scanf("%s",e.dataesame);
                
                E[*pn]=e;
                (*pn)++;
      }
      else printf ("Vettore pieno\n");
   }
                
 void visualizza (struct esame *E, int n)
 {
      
      char dataesame[12];
      int i;
      
      printf("Data esame (gg/mm/aaaa): ");
      scanf("%s",dataesame); 
      
      for(i=0;i<n;i++)
       if(strcmp(E[i].dataesame,dataesame)==0)
        {
            printf("Data esame: %s\n",E[i].dataesame);
            printf("Cognome: %s\n",E[i].cognome);
            printf("Nome: %s\n",E[i].nome);
        }
}

void ordinamento (struct esame *E, int n)
{
     long matricola;
     int i, sup;
     struct esame temp;
     
     for(sup=n-1;sup>0;sup--)
      for(i=0;i<sup;i++) 
        {
          temp=E[i];
          E[i]=E[i+1];
          E[i+1]=temp; 
        }
     
}    
   
     
void salvataggio (struct esame *E, int n)
{
     int i;
     FILE *pf;
     
     pf=fopen("verbaleesami.dat","wb");
     if(pf)
     {
           for(i=0;i<n;i++)
              fwrite(&E[i],sizeof(struct esame),1,pf);
           fclose(pf);
     } 
     else printf("errore il scrittura\n");
}
           
           
void inizializza (struct esame *E, int *pn)
{
     struct esame e;
     int i;
     FILE *pf;
     
     i=0;
     pf=fopen("verbaleesami.dat","rb");
     if(pf)
     {
           while(i<50 && fread(&e,sizeof(struct esame),1,pf)>0)
            { E[i]=e;
             i++;
            }
           fclose(pf);
     }
     else printf("Errore in lettura\n");
     *pn=i;
}

main ()
{
     struct esame E[50];
     int n;
     int scelta;
     
     inizializza(E,&n);
     do 
     {
        printf("Scegli tra:\n");
        printf("1)Inserimento:\n2)Visualizza:\n");
        printf("3)Ordinamento\n4)Salvataggio:\n");
        printf("0)fine\n");
        scanf("%d",&scelta);
        switch(scelta)
         {
           case 1:    inserimento(E,&n);
                      break;
           case 2:    visualizza(E,n);
                      break;
           case 3:    ordinamento(E,n);
                      break; 
           case 4:    salvataggio(E,n);
                      break;
           default:; 
         }
       } while (scelta!=0); 
                                            
}                                           
