/*
Scrivere un programma per la gestione dei passeggeri delle ferrovie. Ogni  passeggero  caratterizzato dalle seguenti informazioni: cognome e nome, numero biglietto, Codice treno, data viaggio.
I passeggeri sono organizzati in memoria come un vettore di 80 elementi
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Inserimento di un nuovo passeggero;
2)Visualizzazione dei passeggeri di un certo treno (chiedere codice treno e data);
3) Cancellazione di un passeggero (chiedere numero biglietto e codice treno);
4) Salvataggio su file dei passeggeri.

All'avvio del programma i valori precedentemente salvate su file devono essere letti e copiati nel vettore mediante una funzione di inizializzazione del vettore. 


*/

#include<stdio.h>
#include <string.h>

struct passeggero
{
       char nominativo [40];
       int numero;
       int codice;
       char data[11];
       };
       
       
void inserisci(struct passeggero *V,int *pn)
{
     struct passeggero g;
     if(*pn<80)
     {
               printf("Nominativo: ");
               scanf("%s",g.nominativo);
               printf("Numero biglietto: ");
               scanf("%d",&g.numero);
               printf("Codice treno: ");
               scanf("%d",&g.codice);
               printf("Data viaggio: ");
               scanf("%s",g.data);
               
               V[*pn]=g;
               (*pn)++;
     }
               else printf("Vettore pieno");
} 



void visualizza(struct passeggero *V,int n)
{
     int i;
     int codice;
     char data[12];
     
     printf("Codice treno: ");
     scanf("%d",&codice);
     printf("Data viaggio: ");
     scanf("%s",data);
     
     for(i=0;i<n;i++)
       if(V[i].codice==codice && strcmp(V[i].data,data)==0)
              {
                            printf("\nNominativo: %s\n",V[i].nominativo);
                            printf("Numero biglietto: %d\n\n",V[i].numero);
              }
}


void cancella(struct passeggero *V,int *pn)
{
     int numero;
     int codice;
     int p;
     int i;
     printf("Numero biglietto: ");
     scanf("%d",&numero);
     printf("Codice treno: ");
     scanf("%d",&codice);
     
     for(p=0;p<*pn;p++)
          if(V[p].numero==numero && V[p].codice==codice)
             break;
    
     if(p<*pn)
     {
         for(i=p;i<*pn-1;i++)
              V[i]=V[i+1];
         (*pn)--;
         printf("Elemento eliminato\n");
     }
     else printf("Elemento non trovato\n");
}




void salva(struct passeggero *V,int n)
{
     int i;
     FILE *pf;
     pf=fopen("passeggeri.dat","wb");
     if(pf)
     {
           for(i=0;i<n;i++)
              fwrite(&V[i],sizeof(struct passeggero),1,pf);
           fclose(pf);
     }
     else printf("File non aperto\n\n");
}



void inizializza(struct passeggero *V,int *pn)
{
     struct passeggero g;
     int i;
     FILE *pf;
     
     i=0;
     pf=fopen("passeggeri.dat","rb");
     if(pf)
     {
           while(i<80 && fread(&g,sizeof(struct passeggero),1,pf)>0);
           {
                      V[i]=g;
                      i++;
           }
           close(pf);
     }
     else printf("Errore lettura\n\n");
     
     *pn=i;
}




main(){
       struct passeggero C[80];
       int n;
       int scelta;
       
       inizializza (C,&n);
       
       do{
                   printf("Scegli tra le seguenti opzioni: ");
                   printf("\n 1 inserisci\n 2 visualizza\n 3 cancella\n 4 salva\n 0 esci\n");
                   scanf("%d",&scelta);
                   switch(scelta){
                                  case 1: inserisci (C,&n);
                                          break;
                                  case 2: visualizza (C,n);
                                          break;
                                  case 3: cancella (C,&n);
                                          break;
                                  case 4: salva (C,n);
                                          break;
                                          default:;
                                  }
          } while(scelta!=0);
  }
     
